#include "colors.inc"
#include "glass.inc"

#declare bird_twist_tex=texture{pigment{Pink}}
#declare sucker_twist_tex=texture{pigment{Flesh}}
#declare sucker_twist2_tex=texture{pigment{Blue} finish{phong 1.0}}
#declare inside_twist_tex=texture{pigment{Brown} finish{phong 1.0}}

#declare petal_1 = object{
 union{
  difference{
   sphere{<0,0,0>,5}
   sphere{<0,0,0>,4.75 texture{inside_twist_tex}} 
   box{<-100,-100,-100>,<100,0,100> texture{inside_twist_tex}}
   box{<0,-100,-100>,<100,100,100> rotate<0,-2.5,0> texture{inside_twist_tex}}
   box{<-100,-100,-100>,<0,100,100> rotate<0,2.5,0> texture{inside_twist_tex}} 
  }
  difference{
   cylinder{<0,0,0>,<0,-10,0>,5}
   cylinder{<0,-100,0>,<0,100,0>,4.75 texture{inside_twist_tex}}   
   box{<0,-100,-100>,<100,100,100> rotate<0,-2.5,0> texture{inside_twist_tex}}
   box{<-100,-100,-100>,<0,100,100> rotate<0,2.5,0> texture{inside_twist_tex}}
  }
 }
}

#declare sucker_1=object{
 union{
  difference{
   cylinder{<0,0,0>,<0,0,-0.15>,0.25}
   cylinder{<0,0,-100>,<0,0,100>,0.15}
  }
  sphere{<0,0,0>,0.15 texture{sucker_twist2_tex}}
 }
}

#declare petal_2 = object{
 union{
  difference{
   sphere{<0,0,0>,4.75}
   sphere{<0,0,0>,4.5 texture{inside_twist_tex}} 
   box{<-100,-100,-100>,<100,0,100> texture{inside_twist_tex}}
   box{<0,-100,-100>,<100,100,100> rotate<0,-7.5,0> texture{inside_twist_tex}}
   box{<-100,-100,-100>,<0,100,100> rotate<0,7.5,0> texture{inside_twist_tex}} 
  }
  object{sucker_1 scale 0.75 translate<0,0,-4.75> rotate<70,0,0>}
  object{sucker_1 translate<0,0,-4.75> rotate<40,0,0>}
  object{sucker_1 translate<0,0,-4.75> rotate<20,0,0>}
  object{sucker_1 translate<0,0,-4.75>}
  object{sucker_1 scale 1.2 translate<0,-1,-4.75>}
  object{sucker_1 translate<0,-2,-4.75>}
  object{sucker_1 scale 1.5 translate<0,-4,-4.75>}  
  difference{
   cylinder{<0,0,0>,<0,-10,0>,4.75}
   cylinder{<0,-100,0>,<0,100,0>,4.5 texture{inside_twist_tex}}
   box{<0,-100,-100>,<100,100,100> rotate<0,-7.5,0> texture{inside_twist_tex}}
   box{<-100,-100,-100>,<0,100,100> rotate<0,7.5,0> texture{inside_twist_tex}}
  }
 }
}

#declare wrapped_ball=object{
 union{
  difference{
   union{
    #declare petal_num=5;
    #declare petal_y_rot=360/petal_num;
    #declare cur_y_rot=0;
    #while(cur_y_rot<360)
     // object{petal_1 rotate<0,cur_y_rot,0>}
     // object{petal_2 rotate<0,cur_y_rot+(petal_y_rot/2),0> pigment{sucker_twist_tex}}
     object{petal_1 rotate<0,0,45> rotate<0,cur_y_rot,0> texture{bird_twist_tex}}
     object{petal_2 rotate<0,0,45> rotate<0,cur_y_rot+(petal_y_rot/2),0> texture{sucker_twist_tex}}
     #declare cur_y_rot=cur_y_rot + petal_y_rot;
    #end
   }
   box{<-100,-100,-100>,<100,-5,100>}
   translate<0,5,0>
  }
  sphere{<0,4,0>,4 texture{T_Dark_Green_Glass} interior{I_Glass}}
 }
}


